﻿
' The hook procedure should process a message in less time than the data entry specified in the 
' LowLevelHooksTimeout value in the following registry key: HKEY_CURRENT_USER\Control Panel\Desktop
' The value is in milliseconds. If the hook procedure does not return during this interval, 
' the system will pass the message to the next hook.

Imports System.Runtime.InteropServices

Public Module Keyboard_Hook

    Private Const HC_ACTION As Integer = 0
    Private Const WH_KEYBOARD_LL As Integer = 13
    Private Const WM_KEYDOWN As Integer = &H100
    Private Const WM_KEYUP As Integer = &H101
    Private Const WM_SYSKEYDOWN As Integer = &H104
    Private Const WM_SYSKEYUP As Integer = &H105

    Private Structure KBDLLHOOKSTRUCT
        Public vkCode As Integer
        Public scanCode As Integer
        Public flags As Integer
        Public time As Integer
        Public dwExtraInfo As Integer
    End Structure

    Private Declare Auto Function SetWindowsHookEx Lib "user32" (ByVal idHook As Integer, _
                                                                 ByVal lpfn As LowLevelKeyboardProcDelegate, _
                                                                 ByVal hMod As IntPtr, _
                                                                 ByVal dwThreadId As UInteger) As IntPtr

    Private Declare Auto Function CallNextHookEx Lib "user32" (ByVal hhk As IntPtr, _
                                                               ByVal nCode As Integer, _
                                                               ByVal wParam As Integer, _
                                                               ByVal lParam As KBDLLHOOKSTRUCT) As Integer

    Private Declare Auto Function UnhookWindowsHookEx Lib "user32" (ByVal hhk As IntPtr) As IntPtr

    Private Delegate Function LowLevelKeyboardProcDelegate(ByVal nCode As Integer, _
                                                           ByVal wParam As Integer, _
                                                           ByRef lParam As KBDLLHOOKSTRUCT) As Integer

    Private KeyboardHook As IntPtr = IntPtr.Zero

    Private KeyboardHookDelegate As LowLevelKeyboardProcDelegate = AddressOf LowLevelKeyboardProc

    Private Function LowLevelKeyboardProc(ByVal nCode As Integer, _
                                          ByVal wParam As Integer, _
                                          ByRef lParam As KBDLLHOOKSTRUCT) As Integer
        'Dim tm1 As PerformanceTimer = New PerformanceTimer
        If nCode = HC_ACTION Then
            'Debug.Print(lParam.scanCode & " " & lParam.flags & " " & CommandCode)
            If wParam = WM_KEYDOWN Or _
               wParam = WM_SYSKEYDOWN Or _
               wParam = WM_KEYUP Or _
               wParam = WM_SYSKEYUP Then

                Form1.ShowKey(lParam.scanCode, _
                              lParam.vkCode, _
                              lParam.flags, _
                              lParam.dwExtraInfo, _
                              lParam.time)
                Return 1
            Else
                'MsgBox("NO KEYDOWN/UP", MsgBoxStyle.Information Or MsgBoxStyle.SystemModal)
            End If
        End If
        'tm1.DebugPrintMicrosec()
        Return CallNextHookEx(KeyboardHook, nCode, wParam, lParam)
    End Function


    Public Sub K_hook_DisableKeyboard()
        KeyboardHook = SetWindowsHookEx(WH_KEYBOARD_LL, _
                                        KeyboardHookDelegate, _
                                        Nothing, _
                                        0)
    End Sub

    Public Sub K_hook_EnableKeyboard()
        UnhookWindowsHookEx(KeyboardHook)
    End Sub

End Module


